summaryrefslogtreecommitdiff
path: root/scripts
diff options
context:
space:
mode:
authormkaruza <mario.karuza@gmail.com>2018-06-20 13:16:34 +0200
committerUnknown <mario.karuza@gmail.com>2018-06-20 13:23:38 +0200
commit7a7a61998c60b8114994b29d5f649637be8139e0 (patch)
tree313cddb9f5d03b5973d8473faf7ee11b7c3db10a /scripts
parente5c6580178a8d660c03fe9fab09c539cedf6fb34 (diff)
downloadmariadb-git-7a7a61998c60b8114994b29d5f649637be8139e0.tar.gz
MDEV-15442 xtrabackup-v2 SST donor stuck in DONOR/DESYNCED state when joiner is killed
SST transfer scripts rsync and maribackup now monitor parent process and will cleanup if process dies
Diffstat (limited to 'scripts')
-rw-r--r--scripts/wsrep_sst_mariabackup.sh23
-rw-r--r--scripts/wsrep_sst_rsync.sh2
2 files changed, 24 insertions, 1 deletions
diff --git a/scripts/wsrep_sst_mariabackup.sh b/scripts/wsrep_sst_mariabackup.sh
index 549161aa8f3..ea0a6fc0d51 100644
--- a/scripts/wsrep_sst_mariabackup.sh
+++ b/scripts/wsrep_sst_mariabackup.sh
@@ -644,6 +644,27 @@ send_donor()
}
+monitor_process()
+{
+ local sst_stream_pid=$1
+
+ while true ; do
+
+ if ! ps --pid "${WSREP_SST_OPT_PARENT}" &>/dev/null; then
+ wsrep_log_error "Parent mysqld process (PID:${WSREP_SST_OPT_PARENT}) terminated unexpectedly."
+ kill -- -"${WSREP_SST_OPT_PARENT}"
+ exit 32
+ fi
+
+ if ! ps --pid "${sst_stream_pid}" &>/dev/null; then
+ break
+ fi
+
+ sleep 0.1
+
+ done
+}
+
if [[ ! -x `which $INNOBACKUPEX_BIN` ]];then
wsrep_log_error "${INNOBACKUPEX_BIN} not in path: $PATH"
exit 2
@@ -932,7 +953,7 @@ then
MAGIC_FILE="${DATA}/${INFO_FILE}"
wsrep_log_info "Waiting for SST streaming to complete!"
- wait $jpid
+ monitor_process $jpid
get_proc
diff --git a/scripts/wsrep_sst_rsync.sh b/scripts/wsrep_sst_rsync.sh
index 3d76d1780e2..81120b66d5a 100644
--- a/scripts/wsrep_sst_rsync.sh
+++ b/scripts/wsrep_sst_rsync.sh
@@ -329,6 +329,8 @@ EOF
then
wsrep_log_error \
"Parent mysqld process (PID:$MYSQLD_PID) terminated unexpectedly."
+ kill -- -"${MYSQLD_PID}"
+ sleep 1
exit 32
fi